Update an Estimate Category
Edit an existing estimate category in your ConstructionOnline company account
https://api.constructiononline.com/api/EstimateCategories?catID={catID}
This endpoint allows users to edit an existing estimate category within an estimate in their ConstructionOnline company account. To update an estimate category, users must know the unique numerical ID assigned to the category. The estimate category's ID is stored in the property 'ID'. Only the properties specified in the request body will be updated; the other properties will remain as is. This endpoint cannot be used to update subcategories or items within the estimate category. This endpoint will also not update any locked fields within the ConstructionOnline estimate.
Requests
catID: integer
- Unique identifier for the estimate. This is required for creation.
Category Info: JSON
- Properties to be updated in the estimate category.
- Allowed properties: NAME, DESCRIPTION, COST_CODE, COST_CODE_ID, TRAFFIC_COLOR, BID_NOTES, NOTES_TEAMLINK, NOTES_BID, FIELD_NOTES, NOTES_CLIENTLINK, NOTES_FIELD, GENERAL_NOTES, NOTES_GENERAL
Individual properties for update should be entered as JSON key-value pairs, as seen below:
{
"NAME": "03 - Concrete and Masonry",
"GENERAL_NOTES": "Revised scope, pump truck no longer required"
}
# replace {email} with the email address for your ConstructionOnline account
# {password} with your ConstructionOnline password
# {apikey} with your provided API key
# {catID} with the associated estimate's ID
curl -X POST https://api.constructiononline.com/api/EstimateCategories?catID={catID} -u {email}:{password} -H 'APIKey:{apikey}'
C#
/* replace {username} with the email address for your ConstructionOnline account
{password} with your ConstructionOnline password
{apikey} with your provided API key
{catID} with the associated estimate's ID */
public string MakeRequest(string endpoint, string payload) {
string username = {username};
string password = {password};
string apiKey = {apikey};
string response = "";
var handler = new HttpClientHandler() { AutomaticDecompression = System.Net.DecompressionMethods.GZip };
using (HttpClient client = new HttpClient(handler)) {
client.BaseAddress = new Uri("http://api.constructiononline.com");
client.DefaultRequestHeaders.Accept.Clear();
client.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", System.Convert.ToBase64String(System.Text.Encoding.GetEncoding("ISO-8859-1").GetBytes(username + ":" + password)));
client.DefaultRequestHeaders.Add("APIKey", apiKey);
client.DefaultRequestHeaders.Add("Accept-Encoding", "gzip");
HttpContent content = new StringContent(payload, System.Text.Encoding.UTF32, "application/json");
response = client.PostAsync(endpoint, content).Result.ToString();
}
return response;
}
MakeRequest("api/EstimateCategories?catID={catID}");
Python
#replace {username} with the email address for your ConstructionOnline account
#{password} with your ConstructionOnline password
#{apikey} with your provided API key
#{catID} with the associated estimate's ID
import base64, requests, json
#Global Variables
apikey = {apikey}
username = {username}
password = {password}
#Functions
def makeRequest(endpoint, payload):
url = "https://api.constructiononline.com/" + endpoint
userPass = username + ":" + password
headers = {
"APIKey": apikey,
"Accept-Encoding": "gzip, deflate, br",
"Authorization": "Basic " + base64.b64encode(userPass.encode()).decode(),
}
response = requests.request("POST", url, headers=headers, data=payload)
return json.dumps(json.loads(response.text), indent=2)
#Main Program
print(makeRequest("api/EstimateCategories?catID={catID}"))
JavaScript
/* replace {username} with the email address for your ConstructionOnline account
{password} with your ConstructionOnline password
{apikey} with your provided API key
{catID} with the associated estimate's ID */
username = '{username}';
password = '{password}';
apikey = '{apikey}';
function makeRequest(endpoint, payload) {
auth = btoa('${username}:${password}');
var myHeaders = new Headers();
myHeaders.append("APIKey", apikey);
myHeaders.append("Accept-Encoding", "gzip, deflate, br");
myHeaders.append("Authorization", "Basic ${auth}");
var requestOptions = {
method: 'POST',
body: '',
headers: myHeaders,
redirect: 'follow'
};
fetch("https://api.constructiononline.com/" + endpoint, requestOptions)
.then(response => response.text())
.then(result => console.log(result))
.catch(error => console.log('error', error));
return response;
};
makeRequest("api/EstimateCategories?catID={catID}");
Responses
200: Success
A successful request will return a 200 response with a record of the updated estimate category in the body.
A sample response and property definitions can be found here.
404: Error
The server was not able to locate the resource specified in the request.
429: Error
The user has surpassed the request rate limit for the hour, day, week, or month.
500: Error
There was an internal server error and the server was unable to complete the request.
Last updated: Sep 22, 2026